#!/usr/bin/env python
import os.path
from StringIO import StringIO
import json

from datatypes import Task

def get_conn():
    import MySQLdb
    return MySQLdb.connect('********', '******', '********', 'icfp2016',
                           port=47104)

def taskfile_from_db(num):
    cname = os.path.join('db/cache/%05d' % int(num))
    try:
        return file(cname)
    except IOError:
        pass

    cnx = get_conn()
    cursor = cnx.cursor()
    cursor.execute("select id, task from problems where id=%s" % num)

    dataarr = cursor.fetchone()
    if not dataarr:
        return None
    data = dataarr[1]

    inf = StringIO(data)
    cnx.close()

    with file(cname, 'w') as f:
        f.write(data)

    return inf

def get_all_task_ids():
    cnx = get_conn()
    cursor = cnx.cursor()
    cursor.execute("select id from problems where task is not NULL")
    nums = [r[0] for r in cursor.fetchall()]
    nums.sort()
    assert len(nums) == len(set(nums))
    return nums


def task_from_db(num):
    return Task(taskfile_from_db(num))

def add_solution(num, text):
    pass

def mark_solved_by(num, label):
    with file('db/solved/%05d' % num, 'w') as f:
        f.write(label)

def is_solved(num):
    return os.path.exists('db/solved/%05d' % num)

def mark_tried_by(num, label):
    with file('db/tried/%05d' % num, 'a') as f:
        print >>f, label

def is_tried_by(num, label):
    try:
        with file('db/tried/%05d' % num, 'r') as f:
            labels = f.read().splitlines()
            return label in labels
    except IOError:
        return False

def send_solution_to_orgs(task_id, text):
    import requests
    request = requests.post(
        "http://2016sv.icfpcontest.org/api/solution/submit",
        headers={
            'X-API-Key': '45-04bd504a84d1c81f9545bcc3076c3323',
            'Accept-Encoding': 'gzip'
        },
        files={'solution_spec': StringIO(text)},
        data={'problem_id': str(task_id)}
    )
    return json.loads(request.text)

if __name__ == '__main__':
    import sys
    print taskfile_from_db(sys.argv[1]).read()
