#!/usr/bin/env python
from Tkinter import *
import threading,sys
import random
import db
import itertools
import random
import solver
import requests,gzip,json,tkMessageBox
from StringIO import StringIO
from fractions import *
colors = ["red", "orange", "yellow", "green", "blue", "violet","black","brown","cyan","white"]
from datatypes import *

def scale(poly,factor,origin,pivot):
    return map(lambda x:(int((x.x-pivot.x)*factor+origin.x),int(origin.y-(x.y-pivot.y)*factor)),poly)
def scalepoint(point,factor,origin,pivot):
    x,y=point.x,point.y
    return (int((x-pivot.x)*factor+origin.x),int(origin.y-(y-pivot.y)*factor))
        
class Board:
    
    def __init__(self,solution=None):
        self.size=250
        self.margin=80
        self.master = Tk()
        self.tframe=Frame(self.master)
        self.tframe.pack(side=TOP,expand=1)

        self.sframe=Frame(self.master)
        self.sframe.pack(side=TOP,expand=1)
        self.cframe=Frame(self.master)
        self.cframe.pack(side=TOP,expand=1)
        
        self.bframe=Frame(self.master)
        self.bframe.pack(side=TOP,expand=1)
        
        self.lcanv = Canvas(self.master, width=(self.size+2*self.margin), height=2*self.margin+self.size,background="grey28")
        self.lcanv.pack(side=LEFT, expand=1)
        self.lcanv.bind("<Button-1>", self.lclick)

        self.ccanv = Canvas(self.master, width=(self.size+2*self.margin), height=2*self.margin+self.size,background="grey22")
        self.ccanv.pack(side=LEFT, expand=1)
        self.ccanv.bind("<Button-1>", self.cclick)

        self.rcanv = Canvas(self.master, width=(self.size+2*self.margin), height=2*self.margin+self.size,background="grey28")
        self.rcanv.pack(side=LEFT, expand=1)

        
        #self.taskno=IntVar()
        #self.no=Entry(self.tframe,textvariable=self.taskno)
        #self.no.pack(side=LEFT)
        #self.ok=Button(self.tframe,text='OK',command=lambda:self.drawno(self.taskno.get()))
        #self.ok.pack(side=LEFT)
        self.reset=Button(self.tframe,text='Reset',command=self.resett)
        self.reset.pack(side=LEFT)
        spacer=LabelFrame(self.tframe,width=100)
        spacer.pack(side=LEFT)
        self.numer = Scale(self.sframe, from_=1, to=1000,orient=HORIZONTAL,length=self.size*3)
        self.numer.pack(side=LEFT,expand=1)
        self.denom = Scale(self.cframe, from_=2, to=1000,orient=HORIZONTAL,length=self.size*3)
        self.denom.pack(side=LEFT,expand=1)


       
        self.node=Button(self.tframe,text='Node',command=self.node)
        self.node.pack(side=LEFT)
        self.edge=Button(self.tframe,text='Edge',command=self.edge)
        self.edge.pack(side=LEFT)
        self.fold=Button(self.tframe,text='Fold',command=self.fold)
        self.fold.pack(side=LEFT)
        self.dump=Button(self.tframe,text='Dump',command=self.dump)
        self.dump.pack(side=LEFT)
        self.dump=Button(self.tframe,text='Clear pointset',command=self.clearpoints)
        self.dump.pack(side=LEFT)
        self.remember=Button(self.tframe,text='Remember',command=self.remember)
        self.remember.pack(side=LEFT)
        
        
        self.master.after(100, lambda: self.master.focus_force())
        self.master.after(110, self.resett)
        
        self.curredge=None
        self.currnode1=None
        self.currnode2=None
        self.pointset=[]
        mainloop()
        print "closing"
        
        #os.kill(os.getpid(),signal.SIGKILL)
        #self.master.close()
    def cclick(self,event):
        a=self.ccanv.find_closest(event.x, event.y)[0]
        self.curredge=(i for i in self.edges if i.widget==a).next()
        self.draw()
    def lclick(self,event):
        a=self.lcanv.find_closest(event.x, event.y)[0]
        self.currnode2=self.currnode1
        self.currnode1=(i for i in self.nodes if i.widget==a).next()
        for i in self.nodes:
            if self.currnode1==i:
                self.pointset.append(self.currnode1)
            
        self.draw()
    def clearpoints(self):
        self.pointset=[]
        self.draw()
    def remember(self):
        for i in self.nodes:
            if "orig" not in dir(i):
                i.orig=Point(i.x,i.y)
        #todo polys
    def draw(self):
        self.lcanv.delete("all")
        
        for i in self.nodes:
            x,y= scalepoint(i,self.size,Point(self.margin,self.margin+self.size),Point(0,0))
            
            bbox=(x-2,y-2,x+2,y+2)
            if self.currnode1 and i==self.currnode1:
                i.widget=self.lcanv.create_oval(bbox,outline="red",fill="red")
            elif self.currnode2 and i==self.currnode2:
                i.widget=self.lcanv.create_oval(bbox,outline="yellow",fill="yellow")
            elif i in self.pointset:
                i.widget=self.lcanv.create_oval(bbox,outline="cyan",fill="cyan")
            else:
                i.widget=self.lcanv.create_oval(bbox,outline="green",fill="green")
        self.ccanv.delete("all")
        for i in self.edges:
            p1,p2 =scalepoint(i.ps[0],self.size,Point(self.margin,self.margin+self.size),Point(0,0))
            p3,p4 =scalepoint(i.ps[1],self.size,Point(self.margin,self.margin+self.size),Point(0,0))
            if self.curredge and i==self.curredge:
                i.widget=self.ccanv.create_line(p1,p2,p3,p4,fill="yellow",arrow=LAST)
            else:
                i.widget=self.ccanv.create_line(p1,p2,p3,p4,fill="red")
        self.lcanv.create_text(20,20,text=len(self.pointset),fill="white")     
            
        
    def drawno(self,tasknumber):
        self.task=db.task_from_db(tasknumber)

        self.state=State(self.task)
        self.drawtask()
    def resett(self):
        self.nodes=[Point(0,0),Point(1,0),Point(1,1),Point(0,1)]
        self.edges=[]
        for i in range(len(self.nodes)):
            self.edges.append(Edge(self.nodes[i-1],self.nodes[i]))
        self.pointset=[]
        self.currnode1=None
        self.curredge=None
        self.draw()
        
    def node(self):
        if self.curredge:
            tedge=self.curredge
            self.curredge=None
            vec=(tedge.ps[1].x-tedge.ps[0].x,tedge.ps[1].y-tedge.ps[0].y)
            newnode=Point(tedge.ps[0].x+Fraction(self.numer.get(),self.denom.get())*vec[0],
                          tedge.ps[0].y+Fraction(self.numer.get(),self.denom.get())*vec[1])
            self.nodes.append(newnode)
            self.edges.append(Edge(tedge.ps[0],newnode))
            self.edges.append(Edge(newnode,tedge.ps[1]))
            self.edges.remove(tedge)
            print len(self.edges)
            self.draw()
            
    def fold(self):
        if self.curredge:
            if self.pointset:
                for i in self.pointset:
                    a=mirror(i,self.curredge.ps[0],self.curredge.ps[1])
                    i.x=a.x
                    i.y=a.y
        self.draw()
    def edge(self):
        self.edges.append(Edge(self.currnode1,self.currnode2))
        self.draw()
    def dump(self):
        pass
    def drawtask(self):
        self.lcanv.delete("all")
        x=min(map(lambda x:x.x,itertools.chain.from_iterable(self.task.polys)))
        y=min(map(lambda x:x.y,itertools.chain.from_iterable(self.task.polys)))
        
        for i in self.task.polys:
            print i
            self.lcanv.create_polygon(scale(i,self.size,Point(self.margin,self.margin+self.size),Point(x,y)),outline="black",fill="grey28" if positive(i) else "red")
        for i in self.task.skeleton:
            self.lcanv.create_polygon(scale(i,self.size,Point(self.margin,self.margin+self.size),Point(x,y)),outline="black")
        #self.lcanv.create_polygon(scale([Point(0,0),Point(1,0),Point(1,1),Point(0,1)],self.size,Point(self.margin,self.margin+self.size),Point(x,y)),outline="white")
        
        #for i in self.state.edges:
        #    self.canv.create_polygon(scale(i.ps,self.size,(3*self.margin+self.size,self.margin+self.size),(x,y)),outline=random.choice(colors))
        c=0
        #for i in self.state.polys:
        #    c=(c+1)%len(colors)
        #    self.canv.create_polygon(scale(trace2poly(i.edges),self.size,(3*self.margin+self.size,self.margin+self.size),(x,y)),outline="black",fill=colors[c])
            #for j in range(len(i.edges)):
            #    dd=scale([((i.edges[j].ps[0][0]+i.edges[j].ps[1][0])/2,(i.edges[j].ps[0][1]+i.edges[j].ps[1][1])/2)],self.size,(3*self.margin+self.size,self.margin+self.size),(x,y))
            #    self.canv.create_text(dd[0][0],dd[0][1],text=`j+1`)
        
        print len(self.state.edges)
    
        
a=Board()
