#!/usr/bin/env python
from Tkinter import *
import threading,sys
import random
import db
import itertools
import random
import solver
import requests,gzip,json,tkMessageBox
from StringIO import StringIO
colors = ["red", "orange", "yellow", "green", "blue", "violet","black","brown","cyan","white"]
from datatypes import *

def scale(poly,factor,origin,pivot):
    return map(lambda x:(int((x.x-pivot.x)*factor+origin.x),int(origin.y-(x.y-pivot.y)*factor)),poly)

        
class Board:
    
    def __init__(self,solution=None):
        self.size=300
        self.margin=180
        self.master = Tk()
        self.tframe=Frame(self.master)
        self.tframe.pack(side=TOP,expand=1)
        
        self.bframe=Frame(self.master)
        self.bframe.pack(side=TOP,expand=1)
        
        self.lcanv = Canvas(self.master, width=(self.size+2*self.margin), height=2*self.margin+self.size,background="grey28")
        self.lcanv.pack(side=LEFT, expand=1)
        self.rcanv = Canvas(self.master, width=(self.size+2*self.margin), height=2*self.margin+self.size,background="grey22")
        self.rcanv.pack(side=LEFT, expand=1)
        self.taskno=IntVar()
        self.no=Entry(self.tframe,textvariable=self.taskno)
        self.no.pack(side=LEFT)
        self.ok=Button(self.tframe,text='OK',command=lambda:self.drawno(self.taskno.get()))
        self.ok.pack(side=LEFT)
        spacer=LabelFrame(self.tframe,width=100)
        spacer.pack(side=LEFT)
        
        self.solve=Button(self.tframe,text='Solve',command=self.locsolve)
        self.solve.pack(side=LEFT)
        self.prev=Button(self.tframe,text='Prev',command=self.prev)
        self.prev.pack(side=LEFT)
        self.next=Button(self.tframe,text='Next',command=self.nexti)
        self.next.pack(side=LEFT)
        self.submit=Button(self.tframe,text='Submit',command=self.submit)
        self.submit.pack(side=LEFT)
        
        
        self.master.after(100, lambda: self.master.focus_force())

        mainloop()
        print "closing"
        
        #os.kill(os.getpid(),signal.SIGKILL)
        #self.master.close()
    def drawno(self,tasknumber):
        self.task=db.task_from_db(tasknumber)

        self.state=State(self.task)
        self.drawtask()
        
    def drawtask(self):
        self.lcanv.delete("all")
        x=min(map(lambda x:x.x,itertools.chain.from_iterable(self.task.polys)))
        y=min(map(lambda x:x.y,itertools.chain.from_iterable(self.task.polys)))
        
        for i in self.task.polys:
            self.lcanv.create_polygon(scale(i,self.size,Point(self.margin,self.margin+self.size),Point(x,y)),outline="black",fill="grey28" if positive(i) else "red")
        for i in self.task.skeleton:
            self.lcanv.create_polygon(scale(i,self.size,Point(self.margin,self.margin+self.size),Point(x,y)),outline="black")
        #for i in self.state.edges:
        #    self.canv.create_polygon(scale(i.ps,self.size,(3*self.margin+self.size,self.margin+self.size),(x,y)),outline=random.choice(colors))
        c=0
        #for i in self.state.polys:
        #    c=(c+1)%len(colors)
        #    self.canv.create_polygon(scale(trace2poly(i.edges),self.size,(3*self.margin+self.size,self.margin+self.size),(x,y)),outline="black",fill=colors[c])
            #for j in range(len(i.edges)):
            #    dd=scale([((i.edges[j].ps[0][0]+i.edges[j].ps[1][0])/2,(i.edges[j].ps[0][1]+i.edges[j].ps[1][1])/2)],self.size,(3*self.margin+self.size,self.margin+self.size),(x,y))
            #    self.canv.create_text(dd[0][0],dd[0][1],text=`j+1`)
        
        print len(self.state.edges)
    def prev(self):
        self.solindex-=1
        self.drawsolution()
    def nexti(self):
        self.solindex+=1
        self.drawsolution()
    def submit(self):
        sol=self.states[self.solindex].dump_solution()
        request = requests.post("http://2016sv.icfpcontest.org/api/solution/submit",
                                headers={'X-API-Key': '45-04bd504a84d1c81f9545bcc3076c3323','Accept-Encoding': 'gzip'},
                                files={'solution_spec':StringIO(sol)},
                                data={'problem_id':self.taskno.get()}
                                )
        
        print sol
        contents = request.text
        

        buf = StringIO( contents)
        try:
            f = gzip.GzipFile(fileobj=buf)
            data = f.read()
            data=json.loads(data)
        except:
            data=contents
        tkMessageBox.showwarning(
            "Assnigger",
            data
        )
    def drawsolution(self):
        
        self.rcanv.delete("all")
        x=min(map(lambda x:x.x,itertools.chain.from_iterable(map(lambda x:trace2poly(x.edges), self.states[self.solindex].polys))))
        y=min(map(lambda x:x.y,itertools.chain.from_iterable(map(lambda x:trace2poly(x.edges), self.states[self.solindex].polys))))
        c=0
        
        for i in self.states[self.solindex].polys:
            c=(c+1)%len(colors)
            self.rcanv.create_polygon(
                scale(trace2poly(i.edges), self.size,
                      Point(self.margin, self.margin+self.size),Point(x, y)),
                outline="black",fill=colors[c])
        self.rcanv.create_text(20,20,text=`self.solindex`,fill="white")
    def locsolve(self):
        
        #print 'vis src polys', self.state.polys
        solState=solver.State(self.state.polys)
        
        self.states=solver.solve(solState)
        print '----- solver returned %s variants' % len(self.states)
        for i, s in enumerate(self.states):
            print '----', i
            print s

        self.solindex=0
        self.drawsolution()
        
a=Board()
